#include <stdio.h>
#include <stdlib.h>
#include "scheduler.h"
#include "fifo.h"
#include "csim.h"

int generate_vcd=0;
FILE *vcdfd=NULL;

int cycle=0;
int ignore_clocks=1;
char force_node_init_value='X';

void Clock(int howmany)
{
SimulateModel(howmany);
}

void tick(void)
{
suckevent(cycle);

if(ignore_clocks)
	{
	Clock(1);

	if(generate_vcd)
		{
		WriteVCDFrame(vcdfd, cycle);
		}
	}
	else
	{
	StkFacName(0, "fifo/ck",0,0);

	Clock(1);

	if(generate_vcd)
		{
		WriteVCDFrame(vcdfd, cycle);
		}

	cycle++;
	StkFacName(1, "fifo/ck",0,0);

	Clock(1);

	if(generate_vcd)
		{
		WriteVCDFrame(vcdfd, cycle);
		}
	}

cycle++;
}

void init(void)
{
int i;

InitializeModelValue(force_node_init_value);
if(!ImportModel("circuit.csim"))
	{
	exit(255);
	}


if(generate_vcd)
	{
	SetVCDtmpsigMode(1);
	vcdfd=OpenVCD("fifo.vcd");
	}

SetSimClockMode(ignore_clocks);
SetGetFacMode(0);	/* fine for this example, but normally should be (1) */
SetGetFacOrder(0);

if(force_node_init_value!='0')		/* if zero, we don't have to do anything special */
	{
	StkFacName(0,"fifo/in_cmd_val",0,0);
	StkFacName(0,"fifo/in_cmd",15,0);
	StkFacName(0, "fifo/pop_cmd",0,0);
	}

StkFacName(0, "fifo/pci_rst",0,0);
tick();

StkFacName(1, "fifo/pci_rst",0,0);
tick();

StkFacName(0, "fifo/pci_rst",0,0);
tick();

for(i=0;i<5;i++) tick();

addevent(25, push_value,next_expected);
addevent(100, pop_value,0);
}


int main(int argc, char **argv)
{
int i;

atexit((void(*)(void))UnloadModel);
init();

for(i=0;;i++) tick();	/* fifo.c is set to die at the 16-bit wraparound */
printf("\n");

exit(0);
}

