#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <stdio.h>
#include <signal.h>
#include <time.h>
#include <math.h>

void sim(void);

unsigned int getint_le_yout(void);
unsigned int getint_le_xout(void);
unsigned int getint_le_mode(void);
unsigned int setint_le_mode(unsigned int v);
unsigned int getint_le_eolnout(void);
unsigned int getint_le_clk(void);
unsigned int setint_le_clk(unsigned int v);
unsigned int getint_le_in2(void);
unsigned int setint_le_in2(unsigned int v);
unsigned int getint_le_in1(void);
unsigned int setint_le_in1(unsigned int v);


XEvent evt;

/*------------------------------------------------------------------ */
#ifndef ITIMER_REAL              /* fixes compiles on suns and linux */
#define ITIMER_REAL     0
#define ITIMER_VIRTUAL  1
#define ITIMER_PROF     2

struct timeval {
        long    tv_sec;         /* seconds */
        long    tv_usec;        /* and microseconds */
};


struct  itimerval {
        struct  timeval it_interval;    /* timer interval */
        struct  timeval it_value;       /* current value */
};
#endif
/*------------------------------------------------------------------ */

#define XWIN_SIZE 256
#define YWIN_SIZE 256

struct sigaction Sig;


/* 
 * Globals...
 */
Display *display;
int numplanes;
Window window;
Pixmap buffer;
int screen;
GC clear, background;
GC pixor;

#ifdef __linux__
struct sigaction Sig;
#endif


int cycles=0;

int in1, in2, mode, xout, yout, eoln;

void sim2(void)
{
setint_le_in1(in1);
setint_le_in2(in2);
setint_le_mode(mode);

sim();

/*** output section ***/

yout=getint_le_yout();
xout=getint_le_xout();
eoln=getint_le_eolnout();

/* printf("xout: %-3d yout: %-3d eoln: %d\n",xout,yout,eoln); */

cycles++;
/*if((cycles&1023)==0) printf("%d\n",cycles);*/

}


void drawline(int x1, int y1, int x2, int y2)
{
in1=x1; in2=x2; mode=0;
sim2(); 
in1=y1; in2=y2; mode=1;
sim2();
mode=2;
sim2();
mode=3;
do	{
	sim2();
	XDrawPoint(display,window,pixor,xout,yout);
	}
	while(!eoln);
}

/*
 * 25Hz screen IRQ...
 */
char init=0;
int lines=0;

void update()
{
int i;

static int x1=10, y1=17, x2=5, y2=23;
static int x1d=3, x2d=5, y1d=4, y2d=3;

while(1)
{
	drawline(x1,y1,x2,y2);
	XFlush(display); 
	x1+=x1d; if((x1<0)|(x1>255)) { x1d=-x1d; x1+=x1d; }
	x2+=x2d; if((x2<0)|(x2>255)) { x2d=-x2d; x2+=x2d; }
	y1+=y1d; if((y1<0)|(y1>255)) { y1d=-y1d; y1+=y1d; }
	y2+=y2d; if((y2<0)|(y2>255)) { y2d=-y2d; y2+=y2d; }

	if(((++lines)&0x7f)==0)
	{
	XCopyArea(display,buffer,window,pixor,0,0,XWIN_SIZE,YWIN_SIZE,0,0);
	XFlush(display);
	}

	while(XCheckMaskEvent(display,EnterWindowMask|LeaveWindowMask,&evt));
}
}


/*
 * Calls all of the X nonsense...
 */
int main(int argc, char **argv)
{
struct itimerval time;
XGCValues val;
unsigned long msk;
unsigned long i,j;

XTextProperty wtitle;
char *window_name="Lines";

sim_init();

if((display=XOpenDisplay((char *)0))==(Display *)0)
   {
   fprintf(stdout,"Cannot Open Display!\n");
   exit(0);
   }

screen=DefaultScreen(display);
numplanes=DisplayPlanes(display,screen);

window=XCreateSimpleWindow(display,RootWindow(display,screen),0,
       0,XWIN_SIZE,YWIN_SIZE, 1, WhitePixel(display,screen), 
WhitePixel(display,screen));

background=XCreateGC(display, window, 0, (XGCValues *)0);
XSetForeground(display,background,WhitePixel(display,screen));

msk=GCFunction;
val.function=GXclear;
clear=XCreateGC(display, window, msk, &val);


val.function=GXcopy;
pixor=XCreateGC(display, window, msk, &val);

XSetForeground(display, pixor, BlackPixel(display,screen));
XSetBackground(display, pixor, BlackPixel(display,screen));

XMapWindow(display, window);
XStringListToTextProperty(&window_name,1,&wtitle);
/* XSetWMName(display,window,&wtitle);  */

XSelectInput(display, window, EnterWindowMask|LeaveWindowMask);
XNextEvent(display, &evt);
XSelectInput(display, window, NoEventMask);

XMapWindow(display, window);
buffer=XCreatePixmap(display,window,XWIN_SIZE,YWIN_SIZE,numplanes);

XFillRectangle(display, buffer, clear, 0, 0, XWIN_SIZE, YWIN_SIZE);
XFillRectangle(display, buffer, background, 0, 0, XWIN_SIZE, YWIN_SIZE);
XFlush(display);




        Sig.sa_handler = update;
        Sig.sa_flags = SA_RESTART;
        sigaction((int)SIGALRM,&Sig,0);

time.it_interval.tv_sec=0;
time.it_interval.tv_usec=40000;  /* make this match your frame rate */
time.it_value.tv_sec=0;
time.it_value.tv_usec=1;

setitimer(ITIMER_REAL, &(time), (struct itimerval *)0);

while(1) { pause(); }
}


