#include <stdio.h>
#include "csim.h"

FILE *vcdfd;
int cycle=0;

void tick(void)
{
StkFacName(1,"top/Clock",0,0);
SimulateModel(1);
WriteVCDFrame(vcdfd, cycle);
cycle++;
StkFacName(0,"top/Clock",0,0);
SimulateModel(1);
WriteVCDFrame(vcdfd, cycle);
cycle++;
}

void Traffic(void)
{
unsigned int i, r, y, g;

for(i=0;i<=19;i++)
	{
	tick();

	printf("(");
	r=GetFacName("top/R",1,1);
	y=GetFacName("top/Y",1,1);
	g=GetFacName("top/G",1,1);
	if(r) { printf("R"); }
	if(y) { printf("Y"); }
	if(g) { printf("G"); }
	if((r|y|g)==0) printf(" ");

	r=GetFacName("top/R",0,0);
	y=GetFacName("top/Y",0,0);
	g=GetFacName("top/G",0,0);
	if(r) { printf("R"); }
	if(y) { printf("Y"); }
	if(g) { printf("G"); }
	if((r|y|g)==0) printf(" ");

	printf(")");
	}
}

int main(int argc, char **argv)
{

atexit((void(*)(void))UnloadModel);

if(!ImportModel("circuit.csim"))
        {
        exit(255);
        }

SetVCDtmpsigMode(1);
vcdfd=OpenVCD("light.vcd");

SetSimClockMode(0);
SetGetFacMode(1);       /* autoeval if model dirty */

printf("Using Slower Pattern (reset default)...\n");
StkFacName(1,"top/I",2,0);
tick();
StkFacName(0,"top/I",2,0);

Traffic();

printf("\nUsing Faster Pattern...\n");
tick();
StkFacName(2,"top/I",2,0);
tick();
StkFacName(0,"top/I",2,0);
Traffic();

printf("\nUsing Blinking Pattern...\n");
tick();
StkFacName(4,"top/I",2,0);
tick();
StkFacName(0,"top/I",2,0);
Traffic();
printf("\n");

exit(0);
}
