#include "ana.h"
#include "ana_glob.h"
#include "mem.h"
#include <ctype.h>
#include <string.h>
#include <stdio.h>


char *convertbuffer=NULL;
int convertlen=0;
char which_search=0;


void Search_01Xud(char *which)
{
int curtim;
hptr h;
int val2find=0;
int prevval=1; 	/* X for good measure */

    if( not selectedTrace )
      {
	PRINT( "\nSelect a trace first!" );
	XBell( display, 0 );
	return;
      }


    switch( *which )
      {
	case '0' : 
		val2find=0;
		break;

	case '1' :
		val2find=3;
		break;

	case 'X' :
		val2find=1;
		break;

	case 'u' :
		val2find=8;	/* upclock code */
		break;

	case 'd' :
		val2find=16;	/* downclock code */
		break;

      }


if(selectedTrace->vector)
	{
	if(selectedTrace->n.vec->nbits!=1)
		{
	        PRINT( "\nBit search on a vector >1 bit wide is invalid!" );
       	 	XBell( display, 0 );
	        return;
		}
	}

curtim=tims.cursor;

h=selectedTrace->cache[0].cursor; /* transition before cursor's curval */
while(h)
	{
	if
	((h->time>curtim)&&
	((h->val==val2find)
	||((val2find==8)&&(h->val==3)&&((prevval==0)||(prevval==1)))
	||((val2find==16)&&(h->val==0)&&((prevval==1)||(prevval==3)))))
		{
		int delta;
		char sprintfbuff[80];

		if(h->time>max_time) goto search_failed;

		tims.cursor=h->time;
		delta=tims.end-tims.start;

		if((tims.cursor+delta)>max_time)
			{
			delta=(max_time-tims.cursor)/2;
			}
		if((tims.cursor-delta)<min_time)
			{
			delta=(tims.cursor-min_time)/2;
			}
		
		if((tims.cursor!=max_time)&&(tims.cursor!=min_time))
			{
			tims.start=tims.cursor-delta;
			tims.end=tims.cursor+delta;
			tims.steps=2*delta;
			}
			else
			{
			tims.start=(Ulong)min_time;
			tims.steps=max_time-min_time;
			tims.end=max_time;
			}

		UpdateTraceCache(0);
		DrawCursVal(cursorBox);

		RedrawTimes();
    		UpdateScrollBar();
    		DrawTraces( tims.start, tims.end );

		sprintf(sprintfbuff,"\nFound at [%.2f]",
			((float)(tims.cursor))/100.0);
		PRINT(sprintfbuff);
		return;
		}

	prevval=h->val;	/* for up/downclock calculations */
	h=h->next;
	}

search_failed:
PRINT( "\nSearch failed!" );
return;
}


char search_matrix[4][4]= /* row == pat, col == val to compare against */
	{
	    /*    0  X  -  1     */
	/* 0 */	{ 1, 0, 0, 0 },
	/* X */	{ 1, 1, 0, 1 },
	/* - */	{ 0, 0, 1, 0 },
	/* 1 */	{ 0, 0, 0, 1 }
	};

void Search_Value(char *which)	/* b/c query called fnt is event driven */
{
switch(which_search=*which)
	{
	case 'h':
		Query("\nEnter hex value > ", Search_Value2);		
		return;

	case 'o':
		Query("\nEnter octal value > ", Search_Value2);		
		return;

	case 'b':
		Query("\nEnter binary value > ", Search_Value2);		
		return;
	}
}


void Search_Value2(char *string_from_query)
{
char *search_bits=NULL;
hptr *h=NULL;
int bits,i;
int mintime, minpos;
int delta;
char sprintfbuff[80];

    if( not selectedTrace )
      {
	PRINT( "\nSelect a trace first!" );
	XBell( display, 0 );
	return;
      }

if(selectedTrace->vector)
	{
	bits=selectedTrace->n.vec->nbits;
	search_bits=(char *)Vcalloc(1,bits);
	h=(hptr *)Vcalloc(bits,bits*sizeof(hptr));
	}
	else
	{
	bits=1;
	search_bits=(char *)Vcalloc(1,bits);
	h=(hptr *)Vcalloc(bits,sizeof(hptr));
	}

for(i=0;i<bits;i++)
	{
	h[i]=selectedTrace->cache[i].cursor;
	}

/*-----*/

switch(which_search)
        {
        case 'h':
                i=strlen(string_from_query);
                if(i)
                if(convertbuffer=convertfromhex(string_from_query))
                        {
                        convertlen=i*4;
                        }       
			else
			{
			PRINT( "\nInvalid hex value!" );			
			goto val_fini;
			}
                break;

        case 'o':
                i=strlen(string_from_query);
                if(i)
                if(convertbuffer=convertfromoctal(string_from_query))
                        {
                        convertlen=i*3;
                        }       
			else
			{
			PRINT( "\nInvalid octal value!" );			
			goto val_fini;
			}
                break;
        case 'b':
                i=strlen(string_from_query);
                if(i)
                if(convertbuffer=convertfrombinary(string_from_query))
                        {
                        convertlen=i;
                        }       
			else
			{
			PRINT( "\nInvalid binary value!" );			
			goto val_fini;
			}
                break;
        }


if(convertbuffer)
	{

	if(convertlen>=bits)
		{
		for(i=0;i<bits;i++)
			{
			search_bits[i]=convertbuffer[convertlen-bits+i];
			}
		}
		else
		for(i=0;i<convertlen;i++)
			{
			search_bits[bits-convertlen+i]=convertbuffer[i];
			}
	Vfree((Pointer) convertbuffer);
	}

/*-----*/

find_smallest_timestep:
mintime=-1;

	for(i=0;i<bits;i++)
		{
		if(mintime==-1)
			{
			if(h[i])
				if(h[i]->next)
					{
					minpos=i;
					mintime=h[i]->next->time;
					}
			}
			else
			{
			if(h[i])
				if(h[i]->next)
					if(h[i]->next->time<mintime)
						{
						minpos=i;
						mintime=h[i]->next->time;
						}
			}
		}


	if(mintime==-1)
		{
		PRINT( "\nSearch failed!" );
		goto val_fini;
		}

	for(i=minpos;i<bits;i++)
		{
		if(h[i])
			{
			if(h[i]->next)
				if(h[i]->next->time==mintime)
					{
					h[i]=h[i]->next;
					if(h[i]->time>max_time)
						{
						PRINT( "\nSearch failed!" );
						goto val_fini;
						}
					}
			}
		}

if(mintime<=tims.cursor) goto find_smallest_timestep;

for(i=0;i<bits;i++)
	{
	if (!search_matrix[search_bits[i]][h[i]->val]) 
		goto find_smallest_timestep;
	}

/*-----*/
		if(mintime>max_time)
			{
			PRINT( "\nSearch failed!" );
			goto val_fini;
			}

		tims.cursor=mintime;
		delta=tims.end-tims.start;

		if((tims.cursor+delta)>max_time)
			{
			delta=(max_time-tims.cursor)/2;
			}
		if((tims.cursor-delta)<min_time)
			{
			delta=(tims.cursor-min_time)/2;
			}
		
		if((tims.cursor!=max_time)&&(tims.cursor!=min_time))
			{
			tims.start=tims.cursor-delta;
			tims.end=tims.cursor+delta;
			tims.steps=2*delta;
			}
			else
			{
			tims.start=(Ulong)min_time;
			tims.steps=max_time-min_time;
			tims.end=max_time;
			}

		UpdateTraceCache(0);
		DrawCursVal(cursorBox);

		RedrawTimes();
    		UpdateScrollBar();
    		DrawTraces( tims.start, tims.end );

		sprintf(sprintfbuff,"\nFound at [%.2f]",
			((float)(tims.cursor))/100.0);
		PRINT(sprintfbuff);

val_fini:
Vfree((Pointer) h);
Vfree((Pointer) search_bits);
}


char *convertfromhex(char *s)
{
char *pnt, *pnt2;
int ch,pos,i;
static char bits[]={8,4,2,1};

pnt=pnt2=(char *)Valloc(strlen(s)*4, 0);
while(ch=(int)(*(s++)))
	{
	switch(ch=toupper(ch))
		{
		case '0': case '1': case '2': case '3': case '4':
		case '5': case '6': case '7': case '8':
		case '9':
			pos=ch-'0';
			break;

		case 'A': case 'B': case 'C': case 'D': case 'E':
		case 'F':
			pos=ch-'A'+10;
			break;

		case 'X':
			pos=16;
			break;

		case '-':
			pos=17;
			break;

		default:
			Vfree((Pointer) pnt);
			return(NULL);			
		}
	
		if(pos<16)
			{
			for(i=0;i<4;i++)
				{
				*(pnt2++)=(pos&bits[i]) ? 3 : 0;		
				}
			}
			else	/* X - */
			{
			char ch2;
			ch2=pos-15;
			for(i=0;i<4;i++)
				{
				*(pnt2++)=ch2;
				}
			}
	}
return(pnt);
}

char *convertfromoctal(char *s)
{
char *pnt, *pnt2;
int ch,pos,i;
static char bits[]={4,2,1};

pnt=pnt2=(char *)Valloc(strlen(s)*3, 0);
while(ch=(int)(*(s++)))
	{
	switch(ch=toupper(ch))
		{
		case '0': case '1': case '2': case '3': case '4':
		case '5': case '6': 
		case '7': 
			pos=ch-'0';
			break;

		case 'X':
			pos=8;
			break;

		case '-':
			pos=9;
			break;

		default:
			Vfree((Pointer) pnt);
			return(NULL);			
		}
	
		if(pos<8)
			{
			for(i=0;i<3;i++)
				{
				*(pnt2++)=(pos&bits[i]) ? 3 : 0;		
				}
			}
			else	/* X - */
			{
			char ch2;
			ch2=pos-7;
			for(i=0;i<3;i++)
				{
				*(pnt2++)=ch2;
				}
			}
	}
return(pnt);
}

char *convertfrombinary(char *s)
{
char *pnt, *pnt2;
int ch,pos;

pnt=pnt2=(char *)Valloc(strlen(s), 0);
while(ch=(int)(*(s++)))
	{
	switch(ch=toupper(ch))
		{
		case '0': 
			pos=0;
			break;

		case '1': 
			pos=3;
			break;

		case 'X':
			pos=1;
			break;

		case '-':
			pos=2;
			break;

		default:
			Vfree((Pointer) pnt);
			return(NULL);			
		}
	
	*(pnt2++)=pos;
	}
return(pnt);
}

