/* 
 * Copyright (c) Tony Bybell 1999.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 */


#include "main.h"
#include "bindings.h"

static int char_position=1;
#define RTSIDE (mx-1)

int op_null(char inchar)
{
return(0);
}

int op_insert(char inchar)
{
return(0);
}

int op_up(void)
{
short mx, my;
int effpos; 
       
if(!curline->prev)
	return(0);

my=maxy-1;
mx=maxx-1;

if(curline->dirty)
	{
	ed_draw_line(current_line_row, curline, mx, my, 0); /* normalize */
	}
else if(curline->offset)
	{
	ed_draw_line(current_line_row, curline, mx, my, 0); /* normalize */
	}


curline=curline->prev;
if(current_line_row!=0)
	{
	current_line_row--;
	}
	else
	{
	short mx, my;

	current_line_base--;
	topline=topline->prev;
	move(0,0);
	insertln();
	}

if(char_position>(curline->len+1))
	{
	effpos=curline->len+1;
	}
	else
	{
	effpos=char_position;
	if(curline->str[effpos-1]=='\t') effpos=((effpos-1)&(~7))+1;
	}


if(effpos>(mx-1))
	{
	current_line_col=RTSIDE;
	curline->offset=effpos-(current_line_col)-1;	
	}
	else
	{
	current_line_col=effpos-1;
	curline->offset=0;
	}

ed_status_bar(); 
ed_draw_line(current_line_row, curline, mx, my, curline->offset);
move(current_line_row,current_line_col);
refresh();

return(0);
}

int op_down(void)
{
short mx, my;
int effpos; 
       
if(!curline->next)
	return(0);

my=maxy-1;
mx=maxx-1;

if(curline->dirty)
	{
	ed_draw_line(current_line_row, curline, mx, my, 0); /* normalize */
	}
else if(curline->offset)
	{
	ed_draw_line(current_line_row, curline, mx, my, 0); /* normalize */
	}

curline=curline->next;
if(current_line_row!=(maxy-2))
	{
	current_line_row++;
	}
	else
	{
	current_line_base++;
	topline=topline->next;
	move(current_line_row+1,0);
	clrtobot();
	move(0,0);
	deleteln();
	}


if(char_position>curline->len+1)
	{
	effpos=curline->len+1;
	}
	else
	{
	effpos=char_position;
	if(curline->str[effpos-1]=='\t') effpos=((effpos-1)&(~7))+1;
	}


if(effpos>(mx-1))
	{
	current_line_col=RTSIDE;
	curline->offset=effpos-(current_line_col)-1;	
	}
	else
	{
	current_line_col=effpos-1;
	curline->offset=0;
	}

ed_status_bar(); 
ed_draw_line(current_line_row, curline, mx, my, curline->offset);
move(current_line_row,current_line_col);
refresh();

return(0);
}

int op_rt(void)
{
short mx, my;

my=maxy-1;
mx=maxx-1;

if(!curline->len)
	{
	if(curline->next)
		{
		current_line_col=0;
		char_position=1;
		op_down();
		}
	}
else
{
int effpos;
effpos=curline->offset+current_line_col+1;

if((effpos==curline->len+1)&&(curline->next))
	{
	current_line_col=0;
	char_position=1;
	op_down();
	}
	else
	{
	if(curline->str[effpos-1]!='\t')
		{
		current_line_col++;
		}
		else
		{
		int neweff;
		neweff=((curline->offset+current_line_col+8)&(~7))+1;
		current_line_col=(current_line_col+(neweff-effpos));
		}

	if(current_line_col>(mx-1))
		{
		current_line_col-=8;
		curline->offset+=8;
		}

	ed_status_bar(); 
	ed_draw_line(current_line_row, curline, mx, my, curline->offset);
	move(current_line_row,current_line_col);
	refresh();
	char_position=curline->offset+current_line_col+1;
	}
}

return(0);
}

int op_lt(void)
{
int effpos;
short mx, my;

my=maxy-1;
mx=maxx-1;

effpos=curline->offset+current_line_col+1;
if(effpos==1)
	{
	if(curline->prev)
		{
		char_position=curline->prev->len+1;
		op_up();
		}
	return(0);
	}

if(curline->str[effpos-2]!='\t')
	{
	current_line_col--;
	}
	else
	{
	int neweff, dcr=2;

	for(neweff=effpos-3;(neweff>=(effpos-9))&&(neweff>=0);neweff--)
		{
		if(((neweff&7)==0)&&(curline->str[neweff]=='\t')) break;
		if(curline->str[neweff]!='\t') {dcr--; break; }
		dcr++;
		}

	if(neweff<0) 
		{
		current_line_col=0;
		curline->offset=0;
		dcr=0;
		}
	
	current_line_col-=dcr;
	}

if 
(((current_line_col<1)&&(curline->offset))||
 ((current_line_col<0)&&(!curline->offset)))
	{
	current_line_col+=8;
	curline->offset-=8;
	effpos=curline->offset+current_line_col+1;
	if(curline->offset<8)
		{
		curline->offset=0;
		current_line_col=effpos-1;
		}
	}

ed_status_bar(); 
ed_draw_line(current_line_row, curline, mx, my, curline->offset);
move(current_line_row,current_line_col);
refresh();
char_position=curline->offset+current_line_col+1;

return(0);
}

int op_pu(char mode)
{
char ch;
short mx, my;
int effpos;

my=maxy-1;
mx=maxx-1;

if(!mode)
	{
	ch=getch();
	}
if((ch==126)||(mode))
	{
	struct line l;
	int ln;
	short my;

	my=maxy-1;
	ln=current_line_base+current_line_row+1;

	if(ln==1)
		{
		return(0);
		}


	if(curline->dirty)
		{

		}

	if(current_line_base<my)
		{
		if(current_line_base==0)
			{
			current_line_row=0;
			curline=topline=textroot;
			}
			else
			{
			int i;
			current_line_row=current_line_base+my-current_line_row-2;
			curline=topline=textroot;
			for(i=0;i<current_line_row;i++)
				{
				curline=curline->next;
				}
			}
		current_line_base=0;
		}
		else
		{
		int i;

		current_line_base-=my;
		for(i=0;i<my;i++)
			{
			curline=curline->prev;
			topline=topline->prev;
			}
		}


if(char_position>curline->len+1)
	{
	effpos=curline->len+1;
	}
	else
	{
	effpos=char_position;
	if(curline->str[effpos-1]=='\t') effpos=((effpos-1)&(~7))+1;
	}


if(effpos>(mx-1))
	{
	current_line_col=RTSIDE;
	curline->offset=effpos-(current_line_col)-1;	
	}
	else
	{
	current_line_col=effpos-1;
	curline->offset=0;
	}

	move(current_line_row,current_line_col);
	ed_refresh_screen();
	}
return(0);
}

int op_pd(char mode)
{
char ch;
short mx, my;
int effpos;

my=maxy-1;
mx=maxx-1;

if(!mode)
	{
	ch=getch();
	}
if((ch==126)||(mode))
	{
	struct line l;
	int ln;
	short my;

	my=maxy-1;
	ln=current_line_base+current_line_row+1;

	if(ln==total_lines)
		{
		return(0);
		}

	if(curline->dirty)
		{

		}

	if(total_lines<=my)
		{
		if(current_line_row==(total_lines-1)) return(0);
		current_line_row=total_lines-1;
		curline=textend;
		}
	else
	if((current_line_base+my)>(total_lines-my))
		{
		struct line *l;
		int i, my2;

		my2=my-1;

		curline=l=textend;
		current_line_row=my-1;

		for(i=0;i<my2;i++)
			{
			l=l->prev;
			}
		topline=l;		

		if(current_line_base!=(total_lines-my))
			{
			int i;
			int cb2;

			cb2=total_lines-my;
			current_line_row=
			current_line_base+my-cb2;			

			curline=topline;
			for(i=0;i<current_line_row;i++)
				{
				curline=curline->next;
				}
			current_line_base=cb2;
			}
			else
			{
			current_line_row=my2;			
			curline=textend;
			}

		}
		else
		{
		int i;

		current_line_base+=my;
		for(i=0;i<my;i++)
			{
			curline=curline->next;
			topline=topline->next;
			}
		}

if(char_position>curline->len+1)
	{
	effpos=curline->len+1;
	}
	else
	{
	effpos=char_position;
	if(curline->str[effpos-1]=='\t') effpos=((effpos-1)&(~7))+1;
	}


if(effpos>(mx-1))
	{
	current_line_col=RTSIDE;
	curline->offset=effpos-(current_line_col)-1;	
	}
	else
	{
	current_line_col=effpos-1;
	curline->offset=0;
	}

	move(current_line_row,current_line_col);
	ed_refresh_screen();
	}
return(0);
}

int op_home(void)
{
return(0);
}


int op_esc_91(void)
{
char ch;

ch=getch();
switch(ch)
	{
	case 49: /* f-keys do later */
	case 50: 
		 break;
	case 65: op_up();
		 break;
	case 66: op_down();
		 break;
	case 67: op_rt();
		 break;
	case 68: op_lt();
		 break;
	case 53: op_pu(0);
		 break;
	case 54: op_pd(0);
		 break;
	case 0:	 op_home();
		 break;	
	default: break;
	}

return(0);
}

int op_esc_79(void)
{
char ch;

ch=getch();
switch(ch)
	{
	case 111: op_insert('/');
		  break;
	case 106: op_insert('*');
		  break;
	case 109: op_insert('-');
		  break;
	case 107: op_insert('+');
		  break;
	case 77:  op_insert('\n');
		  break;
	case 112: op_insert('0');
		  break;
	case 113: op_insert('1');
		  break;
	case 114: op_insert('2');
		  break;
	case 115: op_insert('3');
		  break;
	case 116: op_insert('4');
		  break;
	case 117: op_insert('5');
		  break;
	case 118: op_insert('6');
		  break;
	case 119: op_insert('7');
		  break;
	case 120: op_insert('8');
		  break;
	case 121: op_insert('9');
		  break;
	case 110: op_insert('.');
		  break;
	default:  break;
	}
return(0);
}


int op_esc(char inchar)
{
char ch;

ch=getch();
switch(ch)
	{
	case 79: op_esc_79();
		 break;
	case 91: op_esc_91();
		 break;
	default: break;
	}

return(0);
}


enum OPS { OP_NULL, OP_INSERT, OP_ESC, OP_PU, OP_PD };
int (*op_func[])(char)={op_null, op_insert, op_esc, op_pu, op_pd};

struct action actions[256]=
{
{   0, OP_NULL },
{   1, OP_NULL },
{   2, OP_NULL },
{   3, OP_NULL },
{   4, OP_NULL },
{   5, OP_NULL },
{   6, OP_NULL },
{   7, OP_NULL },
{   8, OP_NULL },
{   9, OP_NULL },
{  10, OP_NULL },
{  11, OP_NULL },
{  12, OP_NULL },
{  13, OP_NULL },
{  14, OP_NULL },
{  15, OP_NULL },
{  16, OP_NULL },
{  17, OP_NULL },
{  18, OP_NULL },
{  19, OP_NULL },
{  20, OP_NULL },
{  21, OP_NULL },
{  22, OP_PD },
{  23, OP_NULL },
{  24, OP_NULL },
{  25, OP_PU },
{  26, OP_NULL },
{  27, OP_ESC  },
{  28, OP_NULL },
{  29, OP_NULL },
{  30, OP_NULL },
{  31, OP_NULL },
{  32, OP_INSERT }, /* ' ' */
{  33, OP_INSERT }, /* '!' */
{  34, OP_INSERT }, /* '"' */
{  35, OP_INSERT }, /* '#' */
{  36, OP_INSERT }, /* '$' */
{  37, OP_INSERT }, /* '%' */
{  38, OP_INSERT }, /* '&' */
{  39, OP_INSERT }, /* ''' */
{  40, OP_INSERT }, /* '(' */
{  41, OP_INSERT }, /* ')' */
{  42, OP_INSERT }, /* '*' */
{  43, OP_INSERT }, /* '+' */
{  44, OP_INSERT }, /* ',' */
{  45, OP_INSERT }, /* '-' */
{  46, OP_INSERT }, /* '.' */
{  47, OP_INSERT }, /* '/' */
{  48, OP_INSERT }, /* '0' */
{  49, OP_INSERT }, /* '1' */
{  50, OP_INSERT }, /* '2' */
{  51, OP_INSERT }, /* '3' */
{  52, OP_INSERT }, /* '4' */
{  53, OP_INSERT }, /* '5' */
{  54, OP_INSERT }, /* '6' */
{  55, OP_INSERT }, /* '7' */
{  56, OP_INSERT }, /* '8' */
{  57, OP_INSERT }, /* '9' */
{  58, OP_INSERT }, /* ':' */
{  59, OP_INSERT }, /* ';' */
{  60, OP_INSERT }, /* '<' */
{  61, OP_INSERT }, /* '=' */
{  62, OP_INSERT }, /* '>' */
{  63, OP_INSERT }, /* '?' */
{  64, OP_INSERT }, /* '@' */
{  65, OP_INSERT }, /* 'A' */
{  66, OP_INSERT }, /* 'B' */
{  67, OP_INSERT }, /* 'C' */
{  68, OP_INSERT }, /* 'D' */
{  69, OP_INSERT }, /* 'E' */
{  70, OP_INSERT }, /* 'F' */
{  71, OP_INSERT }, /* 'G' */
{  72, OP_INSERT }, /* 'H' */
{  73, OP_INSERT }, /* 'I' */
{  74, OP_INSERT }, /* 'J' */
{  75, OP_INSERT }, /* 'K' */
{  76, OP_INSERT }, /* 'L' */
{  77, OP_INSERT }, /* 'M' */
{  78, OP_INSERT }, /* 'N' */
{  79, OP_INSERT }, /* 'O' */
{  80, OP_INSERT }, /* 'P' */
{  81, OP_INSERT }, /* 'Q' */
{  82, OP_INSERT }, /* 'R' */
{  83, OP_INSERT }, /* 'S' */
{  84, OP_INSERT }, /* 'T' */
{  85, OP_INSERT }, /* 'U' */
{  86, OP_INSERT }, /* 'V' */
{  87, OP_INSERT }, /* 'W' */
{  88, OP_INSERT }, /* 'X' */
{  89, OP_INSERT }, /* 'Y' */
{  90, OP_INSERT }, /* 'Z' */
{  91, OP_INSERT }, /* '[' */
{  92, OP_INSERT }, /* '\' */
{  93, OP_INSERT }, /* ']' */
{  94, OP_INSERT }, /* '^' */
{  95, OP_INSERT }, /* '_' */
{  96, OP_INSERT }, /* '`' */
{  97, OP_INSERT }, /* 'a' */
{  98, OP_INSERT }, /* 'b' */
{  99, OP_INSERT }, /* 'c' */
{ 100, OP_INSERT }, /* 'd' */
{ 101, OP_INSERT }, /* 'e' */
{ 102, OP_INSERT }, /* 'f' */
{ 103, OP_INSERT }, /* 'g' */
{ 104, OP_INSERT }, /* 'h' */
{ 105, OP_INSERT }, /* 'i' */
{ 106, OP_INSERT }, /* 'j' */
{ 107, OP_INSERT }, /* 'k' */
{ 108, OP_INSERT }, /* 'l' */
{ 109, OP_INSERT }, /* 'm' */
{ 110, OP_INSERT }, /* 'n' */
{ 111, OP_INSERT }, /* 'o' */
{ 112, OP_INSERT }, /* 'p' */
{ 113, OP_INSERT }, /* 'q' */
{ 114, OP_INSERT }, /* 'r' */
{ 115, OP_INSERT }, /* 's' */
{ 116, OP_INSERT }, /* 't' */
{ 117, OP_INSERT }, /* 'u' */
{ 118, OP_INSERT }, /* 'v' */
{ 119, OP_INSERT }, /* 'w' */
{ 120, OP_INSERT }, /* 'x' */
{ 121, OP_INSERT }, /* 'y' */
{ 122, OP_INSERT }, /* 'z' */
{ 123, OP_INSERT }, /* '{' */
{ 124, OP_INSERT }, /* '|' */
{ 125, OP_INSERT }, /* '}' */
{ 126, OP_INSERT }, /* '~' */
{ 127, OP_INSERT }, /* '' */
{ 128, OP_NULL },
{ 129, OP_NULL },
{ 130, OP_NULL },
{ 131, OP_NULL },
{ 132, OP_NULL },
{ 133, OP_NULL },
{ 134, OP_NULL },
{ 135, OP_NULL },
{ 136, OP_NULL },
{ 137, OP_NULL },
{ 138, OP_NULL },
{ 139, OP_NULL },
{ 140, OP_NULL },
{ 141, OP_NULL },
{ 142, OP_NULL },
{ 143, OP_NULL },
{ 144, OP_NULL },
{ 145, OP_NULL },
{ 146, OP_NULL },
{ 147, OP_NULL },
{ 148, OP_NULL },
{ 149, OP_NULL },
{ 150, OP_NULL },
{ 151, OP_NULL },
{ 152, OP_NULL },
{ 153, OP_NULL },
{ 154, OP_NULL },
{ 155, OP_NULL },
{ 156, OP_NULL },
{ 157, OP_NULL },
{ 158, OP_NULL },
{ 159, OP_NULL },
{ 160, OP_NULL },
{ 161, OP_NULL },
{ 162, OP_NULL },
{ 163, OP_NULL },
{ 164, OP_NULL },
{ 165, OP_NULL },
{ 166, OP_NULL },
{ 167, OP_NULL },
{ 168, OP_NULL },
{ 169, OP_NULL },
{ 170, OP_NULL },
{ 171, OP_NULL },
{ 172, OP_NULL },
{ 173, OP_NULL },
{ 174, OP_NULL },
{ 175, OP_NULL },
{ 176, OP_NULL },
{ 177, OP_NULL },
{ 178, OP_NULL },
{ 179, OP_NULL },
{ 180, OP_NULL },
{ 181, OP_NULL },
{ 182, OP_NULL },
{ 183, OP_NULL },
{ 184, OP_NULL },
{ 185, OP_NULL },
{ 186, OP_NULL },
{ 187, OP_NULL },
{ 188, OP_NULL },
{ 189, OP_NULL },
{ 190, OP_NULL },
{ 191, OP_NULL },
{ 192, OP_NULL },
{ 193, OP_NULL },
{ 194, OP_NULL },
{ 195, OP_NULL },
{ 196, OP_NULL },
{ 197, OP_NULL },
{ 198, OP_NULL },
{ 199, OP_NULL },
{ 200, OP_NULL },
{ 201, OP_NULL },
{ 202, OP_NULL },
{ 203, OP_NULL },
{ 204, OP_NULL },
{ 205, OP_NULL },
{ 206, OP_NULL },
{ 207, OP_NULL },
{ 208, OP_NULL },
{ 209, OP_NULL },
{ 210, OP_NULL },
{ 211, OP_NULL },
{ 212, OP_NULL },
{ 213, OP_NULL },
{ 214, OP_NULL },
{ 215, OP_NULL },
{ 216, OP_NULL },
{ 217, OP_NULL },
{ 218, OP_NULL },
{ 219, OP_NULL },
{ 220, OP_NULL },
{ 221, OP_NULL },
{ 222, OP_NULL },
{ 223, OP_NULL },
{ 224, OP_NULL },
{ 225, OP_NULL },
{ 226, OP_NULL },
{ 227, OP_NULL },
{ 228, OP_NULL },
{ 229, OP_NULL },
{ 230, OP_NULL },
{ 231, OP_NULL },
{ 232, OP_NULL },
{ 233, OP_NULL },
{ 234, OP_NULL },
{ 235, OP_NULL },
{ 236, OP_NULL },
{ 237, OP_NULL },
{ 238, OP_NULL },
{ 239, OP_NULL },
{ 240, OP_NULL },
{ 241, OP_NULL },
{ 242, OP_NULL },
{ 243, OP_NULL },
{ 244, OP_NULL },
{ 245, OP_NULL },
{ 246, OP_NULL },
{ 247, OP_NULL },
{ 248, OP_NULL },
{ 249, OP_NULL },
{ 250, OP_NULL },
{ 251, OP_NULL },
{ 252, OP_NULL },
{ 253, OP_NULL },
{ 254, OP_NULL },
{ 255, OP_NULL }
};

int mainloop(void)
{
char ch;

for(;;)
	{
	ch=getch();
	op_func[actions[ch].action](ch);
	}

}
