/* 
 * Copyright (c) Tony Bybell, Paul Stravers 1999.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 */

/*
 * flatten.h
 * 19/08/97ajb
 */

#ifndef FLATTEN_H
#define FLATTEN_H
#include <string.h>
#include "alloca.h"

#define FLATPRIME 65519


struct qstr
{
struct qstr *next;
char *str;
};

struct flatmodule
{
struct gateport *moduleports;   /* in header */
struct wire *wires;             /* assign'd wires in this module */
struct gate *gates;

struct symslot *symbol[FLATPRIME];

int numgates;
int numwires;
int numregs;			/* regs are lumped in with struct gate *gates */
int numsymbols;
};

void findtopmodule(struct module *);
void findmatchingmodule(struct module *, char *);
void flatten2(struct module *, char *, char *);
void flatten2entry(struct module *, char *, char *);
int hash2(char *);
struct symslot *addflatsym(char *);
struct gateport *flattengate(struct gateport *, char *, int, int);
void dumpflatsym(void);
void queuestring(char *);
void dequeuestring(void);

extern struct module *topmodule, *matchmodule;
extern struct flatmodule *flatmodule;
extern int portmismatches;
extern FILE *ivffile;
extern int noivf;
extern int usecompressed_ids;
extern int mode_pica_vsim_heritage;

#endif

