/* 
 * Copyright (c) Tony Bybell 1999.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 */

/*
 * note..behavioral extensions don't map to VHDL properly yet..
 * laziness on my part...sorry.
 */

#include "symbol.h"
#include "vhdl.h"
#include "y.tab.h"

struct vhdlline  *vbase=NULL, *vnow=NULL;
struct vhdllines *vhdlbase=NULL;
struct gateport  *vhdllastport=NULL;

struct symslot **vhdlports;
int numvhdlports;
int numvhdlcomps;

char *vname;	/* created in namesplit for coalesce */
int vindex;	/* ditto */

int isconstbitrun(struct symslot *b1, struct symslot *b2)
{
if((b1->name[0]!='!')||(b2->name[0]!='!')) return(0);
return(ISCONSTGATE(b1->vhdlgate->type)&&ISCONSTGATE(b2->vhdlgate->type));
}

void namesplit(struct symslot *b)
{
char *s;
int i, len;

s=b->name;
len=strlen(s)-1;
for(i=len;i>0;i--)
        {
        if(s[i]=='/') break;
        }   
         
vname=(char *)calloc(1,i+1+2);
memcpy(vname,s,i);
if (i) vindex=atoi(s+i+1); else vindex=0;
}


void idpnt2(struct symslot *b)
{
char *s, *name;
int i, len, index;

s=b->name;
len=strlen(s)-1;
for(i=len;i>0;i--)
	{
	if(s[i]=='/') break;
	}

name=(char *)calloc(1,i+1+2);
memcpy(name,s,i);
index=atoi(s+i+1);
if (i) index=atoi(s+i+1); else index=0;

if(index)
	{
	printf("%s(%d) ",name,index);
	}
	else
	{
	strcpy(name+i,"/1");
	if(symfind(name))
		{
		*(name+i)=0x00;
		printf("%s(%d) ",name,index);
		}
	else
		{
		*(name+i)=0x00;
		printf("%s ",name);
		}
	}

free(name);
}

void vhdlgate2(struct gate *g)
{
struct gateport *gp;
char gn[32];

if(!g) return;

printf("( ");

switch(g->type)
	{
	case CONST0:	printf("'0' ) "); return;
	case CONST1:	printf("'1' ) "); return;
	case CONSTX:	printf("'x' ) "); return;
	case CONSTZ:	printf("'z' ) "); return;

	case NOT:	strcpy(gn,""); printf("NOT "); break;
	case BUF:	strcpy(gn,""); break;
	case AND:	strcpy(gn,"AND"); break;
	case OR:	strcpy(gn,"OR"); break;
	case XOR:	strcpy(gn,"XOR"); break;
	case NAND:	strcpy(gn,"NAND"); break;
	case NOR:	strcpy(gn,"NOR"); break;
	case XNOR:	strcpy(gn,"XNOR"); break;
	default:	strcpy(gn,"UNSUPPORTED"); break;
	}

gp=g->port;
while(gp!=(g->outport))
	{
	if(gp->port->name[0]=='!')
		{
		vhdlgate2(gp->port->vhdlgate);
		}
		else
		{	
		idpnt2(gp->port);	
		}

	gp=gp->next;
	if(gp!=(g->outport))
		{
		printf("%s ",gn);
		}
	}

printf(") ");
}

/*
 * the portmap sig dumper...add coalescing to this!
 */
int sigdump(struct bitvec *b, int offset, int width)
{
int pos;
int i;

if((numvhdlcomps*width)!=b->length)
	{
	mesg("** incorrect port width\n");
	return(0);
	}

pos=offset*width;

for(i=0;i<width;i++)
	{
	if(i<width-1)
		{
		if(isconstbitrun(b->bits[pos],b->bits[pos+1]))
			{
			int j, pos2;
			printf("\"");
			pos2=pos;

			for(j=i;j<width;j++)
				{
				if(b->bits[pos2]->name[0]!='!') break;
				if(!ISCONSTGATE(b->bits[pos2]->vhdlgate->type)) break;
				switch(b->bits[pos2]->vhdlgate->type)
					{
					case CONST0: printf("0"); break;
					case CONST1: printf("1"); break;
					case CONSTX: printf("x"); break;
					case CONSTZ: printf("z"); break;
					}
				pos2++;
				}
			printf("\" ");
			i=j-1;
			pos=pos2;
			goto ampersanddo;
			}
		}

	if(b->bits[pos]->name[0]!='!')
		{
		if(i<width-1)	
			{
			char *basename;
			int baseindex;
			int pos2;

			pos2=pos;

			namesplit(b->bits[pos]);	basename=vname; baseindex=vindex;
			namesplit(b->bits[pos+1]);
			
			if(strcmp(vname,basename))
				{
				free(vname); free(basename);
				idpnt2(b->bits[pos2++]);
				}
				else	/* we have a run! */
				{
				int currentindex;
				int dir;

				dir=vindex-baseindex;
				free(vname);
				if((dir!=1)&&(dir!=-1))
					{
					free(basename);
					idpnt2(b->bits[pos2++]);
					}
					else
					{
					int j;

					currentindex=baseindex+dir;
					pos2++;
					for(j=i+1;j<width;j++)
						{
						namesplit(b->bits[pos2]);
						if(strcmp(vname,basename)||(vindex!=currentindex))
							{
							free(vname);
							break;
							}
							else
							{
							currentindex+=dir;
							pos2++;
							}
						}
					currentindex-=dir;
					if(baseindex<currentindex)
						{
						printf("%s(%d to %d) ",basename,baseindex,currentindex);
						}
						else
						{
						printf("%s(%d downto %d) ",basename,baseindex,currentindex);
						}
					free(basename);
					pos=pos2;
					i=j-1;
					}
				}
			pos=pos2;
			}
			else
			{
			idpnt2(b->bits[pos++]);
			}
		}
		else
		{
		if(!ISCONSTGATE(b->bits[pos]->vhdlgate->type))
			{
			vhdlgate2(b->bits[pos++]->vhdlgate);
			}
			else
			{
			switch(b->bits[pos++]->vhdlgate->type)
				{
				case CONST0: printf("'0' "); break;
				case CONST1: printf("'1' "); break;
				case CONSTX: printf("'x' "); break;
				case CONSTZ: printf("'z' "); break;
				}
			}
		}

ampersanddo:
	if(i<(width-1)) printf("& ");
	}

return(~0);
}


void dumpcomps(struct component *cmp)
{
	int i,j;
	int modnum, mstrt, mend, mdir, moffset, mwidth;


if(!cmp) return;

if(cmp->next) dumpcomps(cmp->next);

	if(cmp->isarray)
		{
		mstrt=cmp->arraystart;
		mend=cmp->arrayfin;
		mdir=(mstrt>mend)?-1:1;
		numvhdlcomps=((cmp->arraystart-cmp->arrayfin)*(-mdir))+1;
		}	
		else
		{
		mstrt=0;
		mend=1;
		mdir=1;
		numvhdlcomps=1;
		}

	moffset=0;

	if(cmp->name[0]=='!')	/* fix temp generated comp names to c_name... */
		{
		char *t;
		t=(char *)calloc(1,strlen(cmp->name)+2);
		t[0]='c';
		t[1]='_';
		strcpy(t+2,(cmp->name)+1);
		free(cmp->name);
		cmp->name=t;
		}

	/* some looping mechanism for arrays of comps in this block */
	for(modnum=mstrt;moffset!=numvhdlcomps;moffset++,modnum+=mdir)
	{
	if(!cmp->isarray)
		{
		printf("\n%s:\n",cmp->name);
		}
	else
		{
		printf("\n%s_c_%d:\n",cmp->name,modnum);
		}

	printf("entity work.%s(logic)\n",cmp->type->name);
	printf("portmap(\n");

	invports(cmp->type->moduleports);				
	if(numvhdlports)	/* skip if zero ports */
	if(numvhdlports==cmp->port->length)
		{
		if(cmp->port->vec[0]->name)
		{
		for(i=numvhdlports-1;i>=0;i--)
			{
			for(j=0;j<numvhdlports;j++)
				{
				if(!strcmp(cmp->port->vec[i]->name,
				vhdlports[j]->name)) break; 
				}
			if(j==numvhdlports)
				{
				mesg("** port %s does not exist!\n",
                                     cmp->port->vec[i]->name);
				}
				else
				{
/* dump named ports */
		if((vhdlports[j]->lorange==0)			
			&&(vhdlports[j]->hirange==0))		
			{
			printf("\t%s => ",vhdlports[j]->name);
			mwidth=1;
			if(!sigdump(cmp->port->vec[i],moffset,mwidth))goto finishedvhdlportmap;
			if(i>0)printf(",\n");
			}
			else
			{
			mwidth=vhdlports[j]->hirange-vhdlports[j]->lorange+1;
			if(vhdlports[j]->dir==1)
				{
				printf("\t%s(%d downto %d) => ",
					vhdlports[j]->name,vhdlports[j]->hirange,vhdlports[j]->lorange);

				if(!sigdump(cmp->port->vec[i],moffset,mwidth)) goto finishedvhdlportmap;
				if(i>0)printf(",\n");
				}
				else
				{
				printf("\t%s(%d to %d) => ",
					vhdlports[j]->name,vhdlports[j]->lorange,vhdlports[j]->hirange);
				if(!sigdump(cmp->port->vec[i],moffset,mwidth)) goto finishedvhdlportmap;
				if(i>0)printf(",\n");
				}
			}


				}
			}
		}
		else
		for(i=0;i<numvhdlports;i++)
		{
		if((vhdlports[i]->lorange==0)			
			&&(vhdlports[i]->hirange==0))		
			{
			printf("\t%s => ",vhdlports[i]->name);
			mwidth=1;
			if(!sigdump(cmp->port->vec[(numvhdlports-1)-i],moffset,mwidth)) goto finishedvhdlportmap;
			if(i<(numvhdlports-1))printf(",\n");
			}
			else
			{
			mwidth=vhdlports[i]->hirange-vhdlports[i]->lorange+1;
			if(vhdlports[i]->dir==1)
				{
				printf("\t%s(%d downto %d) => ",
					vhdlports[i]->name,vhdlports[i]->hirange,vhdlports[i]->lorange);
				if(!sigdump(cmp->port->vec[(numvhdlports-1)-i],moffset,mwidth)) goto finishedvhdlportmap;
				if(i<(numvhdlports-1))printf(",\n");
				}
				else
				{
				printf("\t%s(%d to %d) => ",
					vhdlports[i]->name,vhdlports[i]->lorange,vhdlports[i]->hirange);
				if(!sigdump(cmp->port->vec[(numvhdlports-1)-i],moffset,mwidth)) goto finishedvhdlportmap;
				if(i<(numvhdlports-1))printf(",\n");
				}
			}
		} /* for.. */
		} /* if..  */
	else
		{
		mesg("** number of ports mismatch!\n");
		}
finishedvhdlportmap:
	printf(");\n");
	free(vhdlports);
	}
}


void invports(struct gateport *gp)
{
struct gateport *t;
int i,j,np=0;

t=gp;
while(t)
	{
	np++;
	t=t->next;
	}

if((numvhdlports=np))
	{
	vhdlports=(struct symslot **)calloc(np,sizeof(struct symslot *));
	t=gp;
	j=np;
	for(i=0;i<np;i++)
		{
		vhdlports[--j]=t->port;
		t=t->next;
		}
	}
	else
	{
	vhdlports=NULL;
	}	
}

char *id_tmpname(struct symslot *b)
{
   static char s[200];
   char *nm = b->name + 1;
   strcpy(s, "v_");
   strcat(s, nm);
   *strrchr(s, '/') = 0;
   return s;;
}

void declare_tmp_sig(struct symslot *b)
{
   if((!b->lorange)&&(!b->hirange))
      printf("signal\t%-12s : bit;\n",id_tmpname(b));
   else
      if(b->dir==1)
         printf("signal\t%-12s : bit_vector(%d downto %d);\n",
                id_tmpname(b),b->hirange,b->lorange);
      else
         printf("signal\t%-12s : bit_vector(%d to %d);\n",
                id_tmpname(b),b->lorange,b->hirange);
}

void declare_impossible_mux_outsigs()
{
   struct gate *g = currentmod->gates;

   for (; g != 0; g = g->next)
      if (g->type == MUX)
      {
         struct symslot *tru = g->port->next->port;
         struct symslot *sel = g->port->next->next->port;
         /* VHDL syntax does not allow us to nest the WHEN-ELSE construct
          * except in the ELSE branch */
         if(tru->vhdlgate && tru->vhdlgate->type==MUX)
            declare_tmp_sig(tru);
         if(sel->vhdlgate && sel->vhdlgate->type==MUX)
            declare_tmp_sig(sel);
      }
}

void signaldump(void)
{
struct symslot *b;
char *s, *name;
int hv, i, index, len;

/* pass 1-coalesce */
for(hv=0;hv<SYMPRIME;hv++)
	{
	b=currentmod->symbol[hv];
	while(b)
		{
		if(b->name[0]!='!') 
			{
			s=b->name;               
			len=strlen(s)-1;
			for(i=len;i>0;i--)
        			{
        			if(s[i]=='/') break;
        			}
			if(i)
				{ 
				struct symslot *k;

				name=(char *)calloc(1,i+1+2);
				memcpy(name,s,i);  
				if (i) index=atoi(s+i+1); else index=0;

				iswirestmt=~0;
				k=addsym(name,-1);
				iswirestmt=0;

				if(!k->dir) 
					{
					k->dir=1;
					k->lorange=k->hirange=index;
					}
				else
					{
					if(index>k->hirange) k->hirange=index; 
					else
					if(index<k->lorange) k->lorange=index; 
					}

				free(name);
				}
			}
		b=b->next;
		}
	}

/* pass 2 */
for(hv=0;hv<SYMPRIME;hv++)
	{
	b=currentmod->symbol[hv];
	while(b)
		{
		if((b->bitnum==-1)&&(!b->inaccess)&&(!b->outaccess))
			{
			if((!b->lorange)&&(!b->hirange))
				{
				printf("signal\t%-12s : bit;\n",b->name);
				}
				else
				if(b->dir==1)
				{
				printf("signal\t%-12s : bit_vector(%d downto %d);\n",b->name,b->hirange,b->lorange);
				}
				else
				{
				printf("signal\t%-12s : bit_vector(%d to %d);\n",b->name,b->lorange,b->hirange);
				}
			}
		b=b->next;
		}
	}
declare_impossible_mux_outsigs();
printf("\n");
}

void recursevhdlports(struct gateport *gp)
{
struct symslot *s;

if(gp->next) recursevhdlports(gp->next);

s=gp->port;

printf("\t%-12s : ",s->name);
	if(s->inaccess) printf("in  ");
	else if(s->outaccess) printf("out ");

if((s->lorange==0)&&(s->hirange==0))
	{
	printf("bit");
	}
	else
	{
	printf("bit_vector(");
	if(s->dir==1) 
		{
		printf("%d downto %d)",s->hirange,s->lorange);
		}
		else
		{
		printf("%d to %d)",s->lorange,s->hirange);
		}
	};	
if(gp!=vhdllastport) printf(";\n");

}

void entdump(struct module *m)
{
printf("--\n-- %s.logic\n--\n",m->name);
printf("entity %s is port(\n",m->name);

if((vhdllastport=m->moduleports)) recursevhdlports(m->moduleports);

printf(");\n");

printf("end %s;\n\n",m->name);
}

void archdump(struct module *m)
{
printf("architecture logic of %s is\n\n",m->name);

signaldump();

printf("begin\n\n");

vhdldump();
dumpcomps(currentmod->comp);
printf("\nend;\n\n\n");
}

void vhdldump(void)
{
struct vhdllines *v, *vold;

v=vhdlbase;
while(v)
	{
	struct vhdlline *w, *wold;
	w=v->vhdl;
	
	while(w)
		{
		switch(w->typ)
			{
			case VH_STR:
				printf("%s",w->val.str);
				free(w->val.str);
				break;
			case VH_NUM:
				printf("%d",w->val.num);
				break;
			}
		wold=w;
		w=w->next;
		free(wold);
		}

	printf("\n");
	vold=v;
	v=v->next;
	free(vold);
	}
vhdlbase=NULL;
}

void vterm(void)
{
struct vhdllines *v;

v=(struct vhdllines *)calloc(1, sizeof(struct vhdllines));
v->vhdl=vbase;
v->next=vhdlbase;
vhdlbase=v;

vbase=vnow=NULL;
}

struct vhdlline *vget(void)
{
struct vhdlline *v;

v=(struct vhdlline *)calloc(1,sizeof(struct vhdlline));

if(!vbase)
	{
	return(vbase=vnow=v);
	}
	else
	{
	vnow->next=v;
	vnow=v;
	return(v);
	}
}

void vstr(char *s)
{
struct vhdlline *v;

v=vget();
v->typ=VH_STR;
strcpy(v->val.str=(char *)calloc(1,strlen(s)+1),s);
}

void vnum(int i)
{
struct vhdlline *v;

v=vget();
v->typ=VH_NUM;
v->val.num=i;
}

void idpnt(struct symslot *b)
{
char *s, *name;
int i, len, index;


s=b->name;
len=strlen(s)-1;
for(i=len;i>0;i--)
	{
	if(s[i]=='/') break;
	}

name=(char *)calloc(1,i+1+2);
memcpy(name,s,i);
if (i) index=atoi(s+i+1); else index=0;

if(index)
	{
	vstr(name);
	vstr("(");
	vnum(index);
	vstr(") ");
	}
	else
	{
	strcpy(name+i,"/1");
	if(symfind(name))
		{
		*(name+i)=0x00;
		vstr(name);
		vstr("(");
		vnum(index);
		vstr(") ");
		}
	else
		{
		*(name+i)=0x00;
		vstr(name);
		vstr(" ");
		}
	}

free(name);
}

void vhdlgate(struct gate *g)
{
struct gateport *gp;
char gn[32];

if(!g) return;

if (g->type == MUX)
{
	struct symslot *fal = g->port->port;
	struct symslot *tru = g->port->next->port;
	struct symslot *sel = g->port->next->next->port;
        if(tru->vhdlgate && tru->vhdlgate->type==MUX) vstr(id_tmpname(tru));
        else if(tru->name[0]=='!') vhdlgate(tru->vhdlgate);
        else idpnt(tru);
        vstr(" when ");
        if(sel->vhdlgate && sel->vhdlgate->type==MUX) vstr(id_tmpname(sel));
        else if(sel->name[0]=='!') vhdlgate(sel->vhdlgate);
        else idpnt(sel);
        vstr(" = '1' else ");
        if(fal->name[0]=='!') vhdlgate(fal->vhdlgate);
        else idpnt(fal);
}
else if (g->type == LATCH)
{
        struct symslot *d = g->port->port;
	struct symslot *q = g->port->next->port;
        vstr("process begin\nwait until ck'event and ck = 1;\n");
        idpnt(q);
        vstr(" <= ");
        vhdlgate(d->vhdlgate);
        vstr(";\nend process");
}
else
{
vstr("( ");

switch(g->type)
	{
	case CONST0:	vstr("'0' ) "); return;
	case CONST1:	vstr("'1' ) "); return;
	case CONSTX:	vstr("'x' ) "); return;
	case CONSTZ:	vstr("'z' ) "); return;

	case NOT:	strcpy(gn,""); vstr("NOT "); break;
	case BUF:	strcpy(gn,""); break;
	case AND:	strcpy(gn,"AND"); break;
	case OR:	strcpy(gn,"OR"); break;
	case XOR:	strcpy(gn,"XOR"); break;
	case NAND:	strcpy(gn,"NAND"); break;
	case NOR:	strcpy(gn,"NOR"); break;
	case XNOR:	strcpy(gn,"XNOR"); break;
	default:	strcpy(gn,"UNSUPPORTED"); break;
	}

gp=g->port;
while(gp!=(g->outport))
	{
	if(gp->port->name[0]=='!')
		{
		vhdlgate(gp->port->vhdlgate);
		}
		else
		{	
		idpnt(gp->port);	
		}

	gp=gp->next;
	if(gp!=(g->outport))
		{
		vstr(gn);
		vstr(" ");
		}
	}

vstr(") ");
}
}

void do_vhdl_assign(struct gate *g)
{
   int delay = MAX3(g->delayr, g->delayf, g->delayz);
   vstr(id_tmpname(g->outport->port));
   vstr(" <= ");
   vhdlgate(g);
   if(!delay) 
   {
      vstr(";");
      vterm();
   }
   else
   {
      vstr("after ");
      vnum(delay);
      vstr(" ns ;");
      vterm();			
   }
}


void scan_impossible_mux_assigns()
{
   struct gate *g = currentmod->gates;

   for (; g != 0; g = g->next)
      if (g->type == MUX)
      {
         struct symslot *tru = g->port->next->port;
         struct symslot *sel = g->port->next->next->port;
         /* VHDL syntax does not allow us to nest the WHEN-ELSE construct
          * except in the ELSE branch */
         if(tru->vhdlgate && tru->vhdlgate->type==MUX)
            do_vhdl_assign(tru->vhdlgate);
         if(sel->vhdlgate && sel->vhdlgate->type==MUX)
            do_vhdl_assign(sel->vhdlgate);
      }
}

void vhdlmod(struct module *mod)
{
struct module *msave;
struct gate *g;
struct wire *w;

msave=currentmod;
currentmod=mod;

g=mod->gates;
while(g)
	{
           /* if(g->outport->port->name[0]=='!') */
		{
		g->outport->port->vhdlgate=g;
		}

	g=g->next;
	}

g=mod->gates;
while(g)
	{
	int delay;

	delay=MAX3(g->delayr, g->delayf, g->delayz);

	if(g->outport->port->name[0]!='!') 
		{
                if (g->type == LATCH)
                    ;
                    else
                    {
		    idpnt(g->outport->port);
                    vstr("<= ");
                    }
		if(!delay) 
			{
			vstr(";");
			vterm();
			}
			else
			{
			vstr("after ");
			vnum(delay);
			vstr(" ns ;");
			vterm();			
			}
		}

	g=g->next;
	}


w=mod->wires;
while(w)
	{
	int delay;

	delay=MAX3(w->delayr, w->delayf, w->delayz);

	if(w->port2->name[0]!='!') 
		{
                if (w->port2 && w->port2->vhdlgate
                    && (w->port2->vhdlgate->type == LATCH))
                   ;
                   else
                   {
		idpnt(w->port1);
                      vstr("<= ");
                   }
		idpnt(w->port2);
		}
		else
		{
                if (w->port2 && w->port2->vhdlgate
                    && (w->port2->vhdlgate->type == LATCH))
                   ;
                   else
                   {
		idpnt(w->port1);
                      vstr("<= ");
                   }
		vhdlgate(w->port2->vhdlgate);
		}

		if(!delay) 
			{
			vstr(" ;");
			vterm();
			}
			else
			{
			vstr(" after ");
			vnum(delay);
			vstr(" ns ;");
			vterm();
			}

	w=w->next;
	}

scan_impossible_mux_assigns();

entdump(currentmod);
archdump(currentmod);

currentmod=msave;
}


void vhdl(struct module *mod)
{
if(mod->left) vhdl(mod->left);
vhdlmod(mod);
if(mod->right) vhdl(mod->right);
}
